// K9-3
// QT؃NXBinTree<K,V>̗p
// ӁF
// {vÓAL[́y̍~złB
// ŏ̃L[ĺAԍ́yőlzłA
// ő̃L[ĺAԍ́yŏlzłB

import java.util.Scanner;
import java.util.Comparator;

class BinTreeTester {
	static Scanner stdIn = new Scanner(System.in);

	//--- f[^iԍ{j ---//
	static class Data {
		public static final int NO   = 1;	// ԍǂݍނH
		public static final int NAME = 2;	// ǂݍނH

		private Integer no;				// ԍiL[lj
		private String  name;			// 

		//--- L[l ---//
		Integer keyCode() {
			return no;
		}

		//--- \Ԃ ---//
		public String toString() {
			return name;
		}

		//--- f[^̓Ǎ ---//
		void scanData(String guide, int sw) {
			System.out.println(guide + "f[^͂ĂB");

			if ((sw & NO) == NO) {
				System.out.print("ԍF");
				no = stdIn.nextInt();
			}
			if ((sw & NAME) == NAME) {
				System.out.print("F");
				name = stdIn.next();
			}
		}
	}

	//--- j[񋓌^ ---//
	enum Menu {
		ADD(      "}"),
		REMOVE(   "폜"),
		SEARCH(   "T"),
		PRINT(    "\"),
		PRINTR(   "~\"),
		MIN_KEY(  "ŏ̃L[l"),
		MIN_DATA( "ŏ̃L[f[^"),
		MAX_KEY(  "ő̃L[l"),
		MAX_DATA( "ő̃L[f[^"),
		TERMINATE("I");

		private final String message;			// \p

		static Menu MenuAt(int idx) {			// idxł񋓂Ԃ
			for (Menu m : Menu.values())
				if (m.ordinal() == idx)
					return m;
			return null;
		}

		Menu(String string) {				// RXgN^
			message = string;
		}

		String getMessage() {				// \pԂ
			return message;
		}
	}

	//--- j[I ---//
	static Menu SelectMenu() {
		int key;
		do {
			for (Menu m : Menu.values())
				System.out.printf("(%d) %s  ", m.ordinal(), m.getMessage());
			System.out.print("F");
			key = stdIn.nextInt();
		} while (key < Menu.ADD.ordinal() || key > Menu.TERMINATE.ordinal());

		return Menu.MenuAt(key);
	}

	public static void main(String[] args) {
		Menu menu;								// j[
		Data data;								// ǉpf[^Q
		Data ptr;									// Tpf[^Q
		Data temp = new Data();		// Ǎݗpf[^

		class IntegerDecComparator implements Comparator<Integer> {
			public int compare(Integer n1, Integer n2) {
				return (n1 > n2) ? -1 : (n1 < n2) ? 1 : 0;
			}
		}

		//--- ̍~ɂ鏇tsRp[^  ---//
		final IntegerDecComparator INT_DEC_COMP = new IntegerDecComparator();

		BinTree<Integer, Data> tree = new BinTree<Integer, Data>(INT_DEC_COMP);

		do {
			switch (menu = SelectMenu()) {
			 case ADD :					// m[h̑}
					data = new Data();
			 		data.scanData("}", Data.NO | Data.NAME);
			 		tree.add(data.keyCode(), data);
			 		break;

			 case REMOVE :			// m[h̍폜
					temp.scanData("폜", Data.NO);
			 		tree.remove(temp.keyCode());
			 		break;

			 case SEARCH :			// m[h̒T
					temp.scanData("T", Data.NO);
					ptr = tree.search(temp.keyCode());
					if (ptr != null)
						System.out.println("̔ԍ̎" + ptr + "łB");
					else
						System.out.println("Yf[^͂܂B");
					break;

			 case PRINT :				// Sm[hL[l̏ɕ\
					tree.print();
					break;

			 case PRINTR :			// Sm[hL[l̍~ɕ\
					tree.printReverse();
					break;

			 case MIN_KEY : {		// ŏ̃L[l\
					Integer key = tree.getMinKey();
					if (key != null)
						System.out.println("ŏ̃L[l" + key + "łB");
					else
						System.out.println("f[^܂B");
					break;
					}

			 case MIN_DATA :		// ŏ̃L[lf[^\
					ptr = tree.getDataWithMinKey();
					if (ptr != null)
						System.out.println("ŏ̃L[lf[^" + ptr + "łB");
					else
						System.out.println("f[^܂B");
					break;

			 case MAX_KEY : {		// ő̃L[l\
					Integer key = tree.getMaxKey();
					if (key != null)
						System.out.println("ő̃L[l" + key + "łB");
					else
						System.out.println("f[^܂B");
					break;
					}

			 case MAX_DATA :		// ő̃L[lf[^\
					ptr = tree.getDataWithMaxKey();
					if (ptr != null)
						System.out.println("ő̃L[lf[^" + ptr + "łB");
					else
						System.out.println("f[^܂B");
					break;
			}
		} while (menu != Menu.TERMINATE);
	}
}
