// K2-8
// tNX

import java.util.Scanner;

class YMD {
	int y;		// N
	int m;		// i1`12j
	int d;		// i1`31j

	//--- e̓ ---//
	static int[][] mdays = {
		{31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31},		// N
		{31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31},		// [N
	};

	//--- yearN͉[Ni[NF1^NF0j ---//
	static int isLeap(int year) {
		return (year % 4 == 0 && year % 100 != 0 || year % 400 == 0) ? 1 : 0;
	}

	//--- RXgN^i^ꂽtɐݒj---//
	YMD(int y, int m, int d) {
		this.y = y;
		this.m = m;
		this.d = d;
	}

	//--- n̓tԂ ---//
	YMD after(int n) {
		YMD temp = new YMD(this.y, this.m, this.d);
		if (n < 0)
			return before(-n);

		temp.d += n;

		while (temp.d > mdays[isLeap(temp.y)][temp.m - 1]) {
			temp.d -= mdays[isLeap(temp.y)][temp.m - 1];
			if (++temp.m > 12) {
				temp.y++;
				temp.m = 1;
			}
		}
		return temp;
	}

	//--- nO̓tԂ ---//
	YMD before(int n) {
		YMD temp = new YMD(this.y, this.m, this.d);
		if (n < 0)
			return after(-n);

		temp.d -= n;

		while (temp.d < 1) {
			if (--temp.m < 1) {
				temp.y--;
				temp.m = 12;
			}
			temp.d += mdays[isLeap(temp.y)][temp.m - 1];
		}
		return temp;
	}

	public static void main(String[] args) {
		Scanner stdIn = new Scanner(System.in);

		System.out.print("t͂ĂB\n");
		System.out.print("NF");  int y = stdIn.nextInt();
		System.out.print("F");  int m = stdIn.nextInt();
		System.out.print("F");  int d = stdIn.nextInt();
		YMD date = new YMD(y, m, d);

		System.out.print("O^̓t߂܂F");
		int n = stdIn.nextInt();

		YMD d1 = date.after(n);
		System.out.printf("%d̓t%dN%d%dłB\n", n, d1.y, d1.m, d1.d);

		YMD d2 = date.before(n);
		System.out.printf("%dO̓t%dN%d%dłB\n", n, d2.y, d2.m, d2.d);
	}
}

