// K4-4
// int^Œ蒷L[iOobt@pȂj

public class IntArrayQueue {
	private int [] que;			// L[̖{
	private int capacity;		// L[̗e
	private int num;				// ݂̃f[^

	//--- sOFL[ ---//
	public class EmptyIntArrayQueueException extends RuntimeException {
		public EmptyIntArrayQueueException() { }
	}

	//--- sOFL[t ---//
	public class OverflowIntArrayQueueException extends RuntimeException {
		public OverflowIntArrayQueueException() { }
	}


	//--- RXgN^ ---//
	public IntArrayQueue(int maxlen) {
		num = 0;
		capacity = maxlen;
		try {
			que = new int[capacity];				// L[{̗p̔z𐶐
		} catch (OutOfMemoryError e) {		// łȂ
			capacity = 0;
		}
	}

	//--- L[Ƀf[^GL[ ---//
	public int enque(int x) throws OverflowIntArrayQueueException {
		if (num >= capacity)
			throw new OverflowIntArrayQueueException();			// L[͖t
		que[num++] = x;
		return x;
	}

	//--- L[f[^fL[ ---//
	public int deque() throws EmptyIntArrayQueueException {
		if (num <= 0)
			throw new EmptyIntArrayQueueException();				// L[͋
		int x = que[0];
		for (int i = 0; i < num - 1; i++)
			que[i] = que[i + 1];
		num--;
		return x;
	}

	//--- L[f[^s[Ni擪f[^`j ---*/
	public int peek() throws EmptyIntArrayQueueException {
		if (num <= 0)
			throw new EmptyIntArrayQueueException();			// L[͋
		return que[num - 1];
	}

	//--- L[xTăCfbNXiȂ-1jԂ---//
	public int indexOf(int x) {
		for (int i = 0; i < num; i++)
			if (que[i]  == x)					// T
				return i;
		return -1;									// Ts
	}

	//--- L[ɂ ---//
	public void clear() {
		num = 0;
	}

	//--- L[̗eʂԂ ---//
	public int capacity() {
		return capacity;
	}

	//--- L[ɒ~Ăf[^Ԃ ---//
	public int size() {
		return num;
	}

	//--- L[͋ł邩 ---//
	public boolean isEmpty() {
		return num <= 0;
	}

	//--- L[͖tł邩 ---//
	public boolean isFull() {
		return num >= capacity;
	}

	//--- L[̑Sf[^擪̏ɕ\ ---//
	public void dump() {
		if (num <= 0)
			System.out.println("L[͋łB");
		else {
			for (int i = 0; i < num; i++)
				System.out.print(que[i] + " ");
			System.out.println();
		}
	}
}

