// K6-16
// q[v\[gi\[g̉ߒڍׂɕ\j

import java.util.Scanner;

class HeapSortEx {

	//--- z̗vfa[idx1]a[idx2] ---//
	static void swap(int[] a, int idx1, int idx2) {
		int t = a[idx1];  a[idx1] = a[idx2];  a[idx2] = t;
	}

	//--- 2n߂ ---*/
	static int pow2(int n) {
		int k = 1;

		while (n-- > 0)
			k *= 2;
		return k;
	}

	//--- n̃Xy[X\ ---//
	static void dispSpace(int n) {
		for (int i = 0; i < n; i++)
			System.out.print(' ');
	}

	//--- q[v\ ---//
	static void dispHeap(int a[], int n) {
		int i = n;
		int height = 1;						// ؂̍
		while ((i >>= 1) > 0)
			height++;
		i = 0;
		int w = 1;
		Loop : {
			for (int level = 0; level < height; level++) {
				dispSpace(pow2(height - level) - 2);
				for (int k = 0; k < w; k++) {
					System.out.printf("%02d", a[i++]);
					if (i >= n) break Loop;
					if (k < w - 1)
						dispSpace(pow2(height - level + 1) - 2);
				}
				System.out.println();
	
				dispSpace(pow2(height - level) - 3);
				for (int k = 0; k < w; k++) {
					if (2 * k + i     < n) System.out.print("^");
					if (2 * k + i + 1 < n) System.out.print("_");
					if (k < w - 1)
						dispSpace(pow2(height - level + 1) - 4);
				}
				System.out.println();
				w *= 2;
			}
		}
		System.out.println();
		System.out.println();
	}

	//--- a[left]`a[right]q[v ---//
	static void downHeap(int[] a, int left, int right) {
		int temp = a[left];		// 
		int child;						// 傫ق̎q
		int parent;						// e

		for (parent = left; parent < (right + 1) / 2; parent = child) {
			int cl = parent * 2 + 1;		// ̎q
			int cr = cl + 1;						// E̎q
			child = (cr <= right && a[cr] > a[cl]) ? cr : cl;	// 傫ق
			if (temp >= a[child])
				break;
			a[parent] = a[child];
		}
		a[parent] = temp;
	}

	//--- q[v\[g ---//
	static void heapSort(int[] a, int n) {
		for (int i = (n - 1) / 2; i >= 0; i--) {		// a[i]`a[n-1]q[v
			dispHeap(a, n);
			downHeap(a, i, n - 1);
		}

		for (int i = n - 1; i > 0; i--) {
			swap(a, 0, i);					// ővfƖ\[gvf
			dispHeap(a, n);
			downHeap(a, 0, i - 1);	// a[0]`a[i-1]q[v
		}
	}

	public static void main(String[] args) {
		Scanner stdIn = new Scanner(System.in);

		System.out.println("q[v\[g");
		System.out.print("vfF");
		int nx = stdIn.nextInt();
		int[] x = new int[nx];

		for (int i = 0; i < nx; i++) {
			System.out.print("x[" + i + "]F");
			x[i] = stdIn.nextInt();
		}

		heapSort(x, nx);	// zxq[v\[g
		
		System.out.println("Ƀ\[g܂B");
		for (int i = 0; i < nx; i++)
			System.out.println("x[" + i + "]" + x[i]);
	}
}

