// K6-14
// NCbN\[gi󂯎͂Qj

import java.util.Scanner;

class QuickSort3B {

	//--- z̗vfa[idx1]a[idx2]̒l ---//
	static void swap(int[] a, int idx1, int idx2) {
		int t = a[idx1];  a[idx1] = a[idx2];  a[idx2] = t;
	}

	//--- P}\[g ---//
	static void insertionSort(int[] a, int left, int right) {
		for (int i = left + 1; i <= right; i++) {
			int tmp = a[i];
			int j;
			for (j = i; j > left && a[j - 1] > tmp; j--)
				a[j] = a[j - 1];
			a[j] = tmp;
		}
	}

	//--- x[a], x[b], x[c]\[gil̃CfbNXԋpj---//
	static int sort3elem(int[] x, int a, int b, int c) {
		if (x[b] < x[a]) swap(x, b, a);
		if (x[c] < x[b]) swap(x, c, b);
		if (x[b] < x[a]) swap(x, b, a);
		return b;
	}

	//--- NCbN\[g ---//
	static void quickSort(int[] a, int left, int right) {
		if (right - left < 9)								// vf9ł
				insertionSort(a, left, right);	// P}\[g
		else {
			int pl = left;							// J[\
			int pr = right;							// EJ[\
			int m = sort3elem(a, pl, (pl + pr) / 2, pr);	// 擪EE\[g
			int x = a[m];								// 
	
			swap(a, m, right - 1);			// ƖQԖڂ
			pl++;												// J[\PE
			pr -= 2;										// EJ[\Q
	
			do {
				while (a[pl] < x) pl++;
				while (a[pr] > x) pr--;
				if (pl <= pr)
					swap(a, pl++, pr--);
			} while (pl <= pr);
	
			if (left < pr)  quickSort(a, left, pr);
			if (pl < right) quickSort(a, pl, right);
		}
	}

	//--- NCbN\[g ---//
	static void qsort(int[] a, int n) {
		quickSort(a, 0, n - 1);
	}
	
	public static void main(String[] args) {
		Scanner stdIn = new Scanner(System.in);

		System.out.println("NCbN\[g");
		System.out.print("vfF");
		int nx = stdIn.nextInt();
		int[] x = new int[nx];

		for (int i = 0; i < nx; i++) {
			System.out.print("x[" + i + "]F");
			x[i] = stdIn.nextInt();
		}

		qsort(x, nx);				// zxNCbN\[g

		System.out.println("Ƀ\[g܂B");
		for (int i = 0; i < nx; i++)
			System.out.println("x[" + i + "]" + x[i]);
	}
}
