// K8-7
// zXgNXCircularLinkedList<E>̗p

import java.util.Scanner;
import java.util.Comparator;

public class CircularLinkedListTester {
	static Scanner stdIn = new Scanner(System.in);

	//--- f[^iԍ{j ---//
	static class Data {
		static final int NO   = 1;		// ԍǂݍނH
		static final int NAME = 2;		// ǂݍނH

		private Integer no;				// ԍ
		private String  name;			// 

		//--- \Ԃ ---//
		public String toString() {
			return "(" + no + ") " + name;
		}

		//--- f[^̓Ǎ ---//
		void scanData(String guide, int sw) {
			System.out.println(guide + "f[^͂ĂB");

			if ((sw & NO) == NO) {
				System.out.print("ԍF");
				no = stdIn.nextInt();
			}
			if ((sw & NAME) == NAME) {
				System.out.print("F");
				name = stdIn.next();
			}
		}

		//--- ԍɂ鏇tsRp[^  ---//
		public static final Comparator<Data> NO_ORDER =
																					new NoOrderComparator();

		private static class NoOrderComparator implements Comparator<Data> {
			public int compare(Data d1, Data d2) {
				return (d1.no > d2.no) ? 1 : (d1.no < d2.no) ? -1 : 0;
			}
		}

		//--- ɂ鏇tsRp[^  ---//
		public static final Comparator<Data> NAME_ORDER =
																					new NameOrderComparator();

		private static class NameOrderComparator implements Comparator<Data> {
			public int compare(Data d1, Data d2) {
				return d1.name.compareTo(d2.name);
			}
		}
	}

	//--- j[񋓌^ ---//
	public enum Menu {
		ADD_FIRST(  "擪Ƀm[h}"),
		ADD_LAST(   "Ƀm[h}"),
		RMV_FIRST(  "擪m[h폜"),
		RMV_LAST(   "m[h폜"),
		RMV_CRNT(   "ڃm[h폜"),
		CLEAR(      "Sm[h폜"),
		SEARCH_NO(  "ԍŒT"),
		SEARCH_NAME("ŒT"),
		NEXT(       "ڃm[hi߂"),
		PRINT_CRNT( "ڃm[h\"),
		PURGE_NO(   "ԍ̃m[h폜"),
		PURGE_NAME( "ꎁ̃m[h폜"),
		RETRIEVE(   "Cӂ̃m[h\"),
		DUMP(       "Sm[h\"),
		TERMINATE(  "I");

		private final String message;				// \p

		static Menu MenuAt(int idx) {				// idxł񋓂Ԃ
			for (Menu m : Menu.values())
				if (m.ordinal() == idx)
					return m;
			return null;
		}

		Menu(String string) {						// RXgN^
			message = string;
		}

		String getMessage() {						// \pԂ
			return message;
		}
	}

	//--- j[I ---//
	static Menu SelectMenu() {
		int key;
		do {
			for (Menu m : Menu.values()) {
				System.out.printf("(%d) %s  ", m.ordinal(), m.getMessage());
				if ((m.ordinal() % 3) == 2 &&
					  m.ordinal() != Menu.TERMINATE.ordinal())
					System.out.println();
			}
			System.out.print("F");
			key = stdIn.nextInt();
		} while (key < Menu.ADD_FIRST.ordinal() || 
											key > Menu.TERMINATE.ordinal());
		return Menu.MenuAt(key);
	}

	public static void main(String[] args) {
		Menu menu;								// j[
		Data data;								// ǉpf[^Q
		Data ptr;									// Tpf[^Q
		Data temp = new Data();		// Ǎݗpf[^

		CircularLinkedList<Data> list = new CircularLinkedList<Data>();		// Xg𐶐

		do {
			switch (menu = SelectMenu()) {

			 case ADD_FIRST :							// 擪Ƀm[h}
					data = new Data();
					data.scanData("擪ɑ}", Data.NO | Data.NAME);
					list.addFirst(data);
					break;

			 case ADD_LAST :							// Ƀm[h}
					data = new Data();
					data.scanData("ɑ}", Data.NO | Data.NAME);
					list.addLast(data);
					break;

			 case RMV_FIRST :							// 擪m[h폜
					list.removeFirst();
					break;

			 case RMV_LAST :							// m[h폜
					list.removeLast();
					break;

			 case RMV_CRNT :							// ڃm[h폜
					list.removeCurrentNode();
					break;

			 case SEARCH_NO :							// ԍŒT
					temp.scanData("T", Data.NO);
					ptr = list.search(temp, Data.NO_ORDER);
					if (ptr == null)
						System.out.println("̔ԍ̃f[^͂܂B");
					else
						System.out.println("TF" + ptr);
					break;

			 case SEARCH_NAME :						// ŒT
					temp.scanData("T", Data.NAME);
					ptr = list.search(temp, Data.NAME_ORDER);
					if (ptr == null)
						System.out.println("̎̃f[^͂܂B");
					else
						System.out.println("TF" + ptr);
					break;

			 case NEXT :									// ڃm[hɐi߂
					list.next();
					break;

			 case PRINT_CRNT :						// ڃm[h̃f[^\
					list.printCurrentNode();
					break;

			 case DUMP :									// Sm[hXgɕ\
					list.dump();
					break;

			 case CLEAR :									// Sm[h폜
					list.clear();
					break;

			 case PURGE_NO :							// ԍ̃m[h폜
					list.purge(Data.NO_ORDER);
					break;

			 case PURGE_NAME :						// ꎁ̃m[h폜
					list.purge(Data.NAME_ORDER);
					break;

			 case RETRIEVE : {						// Cӂ̃m[h\
					System.out.print("擪牽ԖځF");
					int no = stdIn.nextInt() - 1;
					ptr = list.retrieve(no);
					if (ptr == null)
						System.out.println("f[^݂͑܂B");
					else
						System.out.println("f[^" + ptr.toString() + "łB");
				 }
			 }
		} while (menu != Menu.TERMINATE);
	}
}
